using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;


namespace GridCheckBx
{
	public delegate object GetValueAtRow(int row, string name);

	/// <summary>
	/// Summary description for GridListControlColumnHelper.
	/// </summary>
	public class GridListControlColumnHelper
	{
		public GridListControlColumnHelper()
		{
		}

		private  GetValueAtRow GetValueAtRowName;

		//	private ArrayList indexer = new ArrayList();
		private ArrayList names = new ArrayList();

		private GridListControl glc;
		public void SetColumnOrder(string s, GridListControl glc, GetValueAtRow GetValueAtRowName)
		{
			glc.Grid.BeginUpdate();

			if(this.glc != null)
				this.ResetColumnOrder(glc);

			this.GetValueAtRowName = GetValueAtRowName;//new GetValueAtRow(GetValueAtRowName);

			string[] ss = s.Split(',');
			//	indexer.Clear();
			names.Clear();
			foreach(string name in ss)
			{
				int i = GetColIndex(glc.Grid, name);
				if(i > -1)
				{
					//	this.indexer.Add(i);
					this.names.Add(name);
				}
			}
			glc.Grid.QueryCellInfo += new GridQueryCellInfoEventHandler(Grid_QueryCellInfo);
			glc.Grid.QueryColCount += new GridRowColCountEventHandler(Grid_QueryColCount);
			glc.Grid.EndUpdate();

			glc.Grid.Refresh();
			this.glc = glc;
		}

		public void ResetColumnOrder(GridListControl glc)
		{
			glc.Grid.QueryCellInfo -= new GridQueryCellInfoEventHandler(Grid_QueryCellInfo);
			glc.Grid.QueryColCount -= new GridRowColCountEventHandler(Grid_QueryColCount);
			names.Clear();
			glc.Grid.ResetVolatileData();
		}

		public int GetColIndex(GridControl g, string name)
		{
			int col = -1;
			name = name.ToUpper();
			for(int i = 1; i <= g.ColCount; ++i)
			{
				if(g[0, i].Text.ToUpper() == name)
				{
					col = i-1;
					break;
				}
			}
			return col;
		}

		private void Grid_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			 
			if(e.ColIndex > 0 && e.RowIndex >= 0 && e.ColIndex <= this.names.Count)
			{
				if(GetValueAtRowName != null)
				{
					e.Style.CellValue = GetValueAtRowName(e.RowIndex, names[e.ColIndex-1].ToString());
				}		
			}
		}

		private void Grid_QueryColCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = this.names.Count;
			e.Handled = true;
		}
	}

}
